diff --git a/sys/dev/bnxt/bnxt_sysctl.c b/sys/dev/bnxt/bnxt_en/bnxt_sysctl.c
similarity index 54%
rename from sys/dev/bnxt/bnxt_sysctl.c
rename to sys/dev/bnxt/bnxt_en/bnxt_sysctl.c
index 893e56b61099..cf4e995e1aba 100644
--- a/sys/dev/bnxt/bnxt_sysctl.c
+++ b/sys/dev/bnxt/bnxt_en/bnxt_sysctl.c
@@ -644,6 +554,436 @@ bnxt_create_port_stats_sysctls(struct bnxt_softc *softc)
 	    "rx_stat_err", CTLFLAG_RD,
 	    &softc->rx_port_stats->rx_stat_err, "Received stat err");
 
+	if (BNXT_CHIP_P5(softc) &&
+	    (softc->flags & BNXT_FLAG_FW_CAP_EXT_STATS)) {
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_bytes_cos0", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->tx_bytes_cos0, "Transmitted bytes count cos0");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_packets_cos0", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->tx_packets_cos0, "Transmitted packets count cos0");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_bytes_cos1", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->tx_bytes_cos1, "Transmitted bytes count cos1");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_packets_cos1", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->tx_packets_cos1, "Transmitted packets count cos1");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_bytes_cos2", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->tx_bytes_cos2, "Transmitted bytes count cos2");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_packets_cos2", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->tx_packets_cos2, "Transmitted packets count cos2");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_bytes_cos3", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->tx_bytes_cos3, "Transmitted bytes count cos3");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_packets_cos3", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->tx_packets_cos3, "Transmitted packets count cos3");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_bytes_cos4", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->tx_bytes_cos4, "Transmitted bytes count cos4");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_packets_cos4", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->tx_packets_cos4, "Transmitted packets count cos4");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_bytes_cos5", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->tx_bytes_cos5, "Transmitted bytes count cos5");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_packets_cos5", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->tx_packets_cos5, "Transmitted packets count cos5");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_bytes_cos6", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->tx_bytes_cos6, "Transmitted bytes count cos6");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_packets_cos6", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->tx_packets_cos6, "Transmitted packets count cos6");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_bytes_cos7", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->tx_bytes_cos7, "Transmitted bytes count cos7");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_packets_cos7", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->tx_packets_cos7, "Transmitted packets count cos7");
+
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_bytes_pri0", CTLFLAG_RD,
+		    &softc->tx_bytes_pri[0], "Transmitted bytes count pri0");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_packets_pri0", CTLFLAG_RD,
+		    &softc->tx_packets_pri[0], "Transmitted packets count pri0");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_bytes_pri1", CTLFLAG_RD,
+		    &softc->tx_bytes_pri[1], "Transmitted bytes count pri1");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_packets_pri1", CTLFLAG_RD,
+		    &softc->tx_packets_pri[1], "Transmitted packets count pri1");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_bytes_pri2", CTLFLAG_RD,
+		    &softc->tx_bytes_pri[2], "Transmitted bytes count pri2");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_packets_pri2", CTLFLAG_RD,
+		    &softc->tx_packets_pri[2], "Transmitted packets count pri2");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_bytes_pri3", CTLFLAG_RD,
+		    &softc->tx_bytes_pri[3], "Transmitted bytes count pri3");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_packets_pri3", CTLFLAG_RD,
+		    &softc->tx_packets_pri[3], "Transmitted packets count pri3");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_bytes_pri4", CTLFLAG_RD,
+		    &softc->tx_bytes_pri[4], "Transmitted bytes count pri4");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_packets_pri4", CTLFLAG_RD,
+		    &softc->tx_packets_pri[4], "Transmitted packets count pri4");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_bytes_pri5", CTLFLAG_RD,
+		    &softc->tx_bytes_pri[5], "Transmitted bytes count pri5");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_packets_pri5", CTLFLAG_RD,
+		    &softc->tx_packets_pri[5], "Transmitted packets count pri5");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_bytes_pri6", CTLFLAG_RD,
+		    &softc->tx_bytes_pri[6], "Transmitted bytes count pri6");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_packets_pri6", CTLFLAG_RD,
+		    &softc->tx_packets_pri[6], "Transmitted packets count pri6");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_bytes_pri7", CTLFLAG_RD,
+		    &softc->tx_bytes_pri[7], "Transmitted bytes count pri7");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "tx_packets_pri7", CTLFLAG_RD,
+		    &softc->tx_packets_pri[7], "Transmitted packets count pri7");
+
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri0_tx_duration_us", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->pfc_pri0_tx_duration_us, "Time duration between"
+		    "XON to XOFF and XOFF to XON for pri0");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri0_tx_transitions", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->pfc_pri0_tx_transitions, "Num times transition"
+		    "between XON to XOFF and XOFF to XON for pri0");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri1_tx_duration_us", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->pfc_pri1_tx_duration_us, "Time duration between"
+		    "XON to XOFF and XOFF to XON for pri1");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri1_tx_transitions", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->pfc_pri1_tx_transitions, "Num times transition"
+		    "between XON to XOFF and XOFF to XON for pri1");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri2_tx_duration_us", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->pfc_pri2_tx_duration_us, "Time duration between"
+		    "XON to XOFF and XOFF to XON for pri2");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri2_tx_transitions", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->pfc_pri2_tx_transitions, "Num times transition"
+		    "between XON to XOFF and XOFF to XON for pri2");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri3_tx_duration_us", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->pfc_pri3_tx_duration_us, "Time duration between"
+		    "XON to XOFF and XOFF to XON for pri3");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri3_tx_transitions", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->pfc_pri3_tx_transitions, "Num times transition"
+		    "between XON to XOFF and XOFF to XON for pri3");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri4_tx_duration_us", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->pfc_pri4_tx_duration_us, "Time duration between"
+		    "XON to XOFF and XOFF to XON for pri4");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri4_tx_transitions", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->pfc_pri4_tx_transitions, "Num times transition"
+		    "between XON to XOFF and XOFF to XON for pri4");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri5_tx_duration_us", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->pfc_pri5_tx_duration_us, "Time duration between"
+		    "XON to XOFF and XOFF to XON for pri5");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri5_tx_transitions", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->pfc_pri5_tx_transitions, "Num times transition"
+		    "between XON to XOFF and XOFF to XON for pri5");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri6_tx_duration_us", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->pfc_pri6_tx_duration_us, "Time duration between"
+		    "XON to XOFF and XOFF to XON for pri6");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri6_tx_transitions", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->pfc_pri6_tx_transitions, "Num times transition"
+		    "between XON to XOFF and XOFF to XON for pri6");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri7_tx_duration_us", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->pfc_pri7_tx_duration_us, "Time duration between"
+		    "XON to XOFF and XOFF to XON for pri7");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri7_tx_transitions", CTLFLAG_RD,
+		    &softc->tx_port_stats_ext->pfc_pri7_tx_transitions, "Num times transition"
+		    "between XON to XOFF and XOFF to XON for pri7");
+
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "link_down_events", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->link_down_events, "Num times link states down");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "continuous_pause_events", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->continuous_pause_events, "Num times pause events");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "resume_pause_events", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->resume_pause_events, "Num times pause events"
+		    "resumes");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "continuous_roce_pause_events", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->continuous_roce_pause_events, "Num times roce"
+		    "pause events");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "resume_roce_pause_events", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->resume_roce_pause_events, "Num times roce pause"
+		    "events resumes");
+
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_bytes_cos0", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_bytes_cos0, "Received bytes count cos0");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_packets_cos0", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_packets_cos0, "Received packets count cos0");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_bytes_cos1", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_bytes_cos1, "Received bytes count cos1");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_packets_cos1", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_packets_cos1, "Received packets count cos1");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_bytes_cos2", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_bytes_cos2, "Received bytes count cos2");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_packets_cos2", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_packets_cos2, "Received packets count cos2");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_bytes_cos3", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_bytes_cos3, "Received bytes count cos3");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_packets_cos3", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_packets_cos3, "Received packets count cos3");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_bytes_cos4", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_bytes_cos4, "Received bytes count cos4");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_packets_cos4", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_packets_cos4, "Received packets count cos4");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_bytes_cos5", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_bytes_cos5, "Received bytes count cos5");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_packets_cos5", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_packets_cos5, "Received packets count cos5");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_bytes_cos6", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_bytes_cos6, "Received bytes count cos6");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_packets_cos6", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_packets_cos6, "Received packets count cos6");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_bytes_cos7", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_bytes_cos7, "Received bytes count cos7");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_packets_cos7", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_packets_cos7, "Received packets count cos7");
+
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_bytes_pri0", CTLFLAG_RD,
+		    &softc->rx_bytes_pri[0], "Received bytes count pri0");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_packets_pri0", CTLFLAG_RD,
+		    &softc->rx_packets_pri[0], "Received packets count pri0");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_bytes_pri1", CTLFLAG_RD,
+		    &softc->rx_bytes_pri[1], "Received bytes count pri1");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_packets_pri1", CTLFLAG_RD,
+		    &softc->rx_packets_pri[1], "Received packets count pri1");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_bytes_pri2", CTLFLAG_RD,
+		    &softc->rx_bytes_pri[2], "Received bytes count pri2");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_packets_pri2", CTLFLAG_RD,
+		    &softc->rx_packets_pri[2], "Received packets count pri2");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_bytes_pri3", CTLFLAG_RD,
+		    &softc->rx_bytes_pri[3], "Received bytes count pri3");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_packets_pri3", CTLFLAG_RD,
+		    &softc->rx_packets_pri[3], "Received packets count pri3");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_bytes_pri4", CTLFLAG_RD,
+		    &softc->rx_bytes_pri[4], "Received bytes count pri4");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_packets_pri4", CTLFLAG_RD,
+		    &softc->rx_packets_pri[4], "Received packets count pri4");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_bytes_pri5", CTLFLAG_RD,
+		    &softc->rx_bytes_pri[5], "Received bytes count pri5");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_packets_pri5", CTLFLAG_RD,
+		    &softc->rx_packets_pri[5], "Received packets count pri5");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_bytes_pri6", CTLFLAG_RD,
+		    &softc->rx_bytes_pri[6], "Received bytes count pri6");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_packets_pri6", CTLFLAG_RD,
+		    &softc->rx_packets_pri[6], "Received packets count pri6");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_bytes_pri7", CTLFLAG_RD,
+		    &softc->rx_bytes_pri[7], "Received bytes count pri7");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_packets_pri7", CTLFLAG_RD,
+		    &softc->rx_packets_pri[7], "Received packets count pri7");
+
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri0_rx_duration_us", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->pfc_pri0_rx_duration_us, "Time duration in receiving"
+		    "between XON to XOFF and XOFF to XON for pri0");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri0_rx_transitions", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->pfc_pri0_rx_transitions, "Num times rx transition"
+		    "between XON to XOFF and XOFF to XON for pri0");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri1_rx_duration_us", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->pfc_pri1_rx_duration_us, "Time duration in receiving"
+		    "between XON to XOFF and XOFF to XON for pri1");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri1_rx_transitions", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->pfc_pri1_rx_transitions, "Num times rx transition"
+		    "between XON to XOFF and XOFF to XON for pri1");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri2_rx_duration_us", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->pfc_pri2_rx_duration_us, "Time duration in receiving"
+		    "between XON to XOFF and XOFF to XON for pri2");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri2_rx_transitions", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->pfc_pri2_rx_transitions, "Num times rx transition"
+		    "between XON to XOFF and XOFF to XON for pri2");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri3_rx_duration_us", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->pfc_pri3_rx_duration_us, "Time duration in receiving"
+		    "between XON to XOFF and XOFF to XON for pri3");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri3_rx_transitions", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->pfc_pri3_rx_transitions, "Num times rx transition"
+		    "between XON to XOFF and XOFF to XON for pri3");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri4_rx_duration_us", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->pfc_pri4_rx_duration_us, "Time duration in receiving"
+		    "between XON to XOFF and XOFF to XON for pri4");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri4_rx_transitions", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->pfc_pri4_rx_transitions, "Num times rx transition"
+		    "between XON to XOFF and XOFF to XON for pri4");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri5_rx_duration_us", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->pfc_pri5_rx_duration_us, "Time duration in receiving"
+		    "between XON to XOFF and XOFF to XON for pri5");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri5_rx_transitions", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->pfc_pri5_rx_transitions, "Num times rx transition"
+		    "between XON to XOFF and XOFF to XON for pri5");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri6_rx_duration_us", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->pfc_pri6_rx_duration_us, "Time duration in receiving"
+		    "between XON to XOFF and XOFF to XON for pri6");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri6_rx_transitions", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->pfc_pri6_rx_transitions, "Num times rx transition"
+		    "between XON to XOFF and XOFF to XON for pri6");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri7_rx_duration_us", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->pfc_pri7_rx_duration_us, "Time duration in receiving"
+		    "between XON to XOFF and XOFF to XON for pri7");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "pfc_pri7_rx_transitions", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->pfc_pri7_rx_transitions, "Num times rx transition"
+		    "between XON to XOFF and XOFF to XON for pri7");
+
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_bits", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_bits, "total number of received bits");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_buffer_passed_threshold", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_buffer_passed_threshold, "num of events port"
+		    "buffer"
+		    "was over 85%");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_pcs_symbol_err", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_pcs_symbol_err, "num of symbol errors wasn't"
+		    "corrected by FEC");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_corrected_bits", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_corrected_bits, "num of bits corrected by FEC");
+
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_discard_bytes_cos0", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_discard_bytes_cos0, "num of rx discard bytes"
+		    "count on cos0");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_discard_packets_cos0", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_discard_packets_cos0, "num of rx discard packets"
+		    "count on cos0");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_discard_bytes_cos1", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_discard_bytes_cos1, "num of rx discard bytes"
+		    "count on cos1");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_discard_packets_cos1", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_discard_packets_cos1, "num of rx discard packets"
+		    "count on cos1");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_discard_bytes_cos2", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_discard_bytes_cos2, "num of rx discard bytes"
+		    "count on cos2");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_discard_packets_cos2", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_discard_packets_cos2, "num of rx discard packets"
+		    "count on cos2");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_discard_bytes_cos3", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_discard_bytes_cos3, "num of rx discard bytes"
+		    "count on cos3");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_discard_packets_cos3", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_discard_packets_cos3, "num of rx discard packets"
+		    "count on cos3");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_discard_bytes_cos4", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_discard_bytes_cos4, "num of rx discard bytes"
+		    "count on cos4");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_discard_packets_cos4", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_discard_packets_cos4, "num of rx discard packets"
+		    "count on cos4");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_discard_bytes_cos5", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_discard_bytes_cos5, "num of rx discard bytes"
+		    "count on cos5");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_discard_packets_cos5", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_discard_packets_cos5, "num of rx discard packets"
+		    "count on cos5");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_discard_bytes_cos6", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_discard_bytes_cos6, "num of rx discard bytes"
+		    "count on cos6");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_discard_packets_cos6", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_discard_packets_cos6, "num of rx discard packets"
+		    "count on cos6");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_discard_bytes_cos7", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_discard_bytes_cos7, "num of rx discard bytes"
+		    "count on cos7");
+		SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
+		    "rx_discard_packets_cos7", CTLFLAG_RD,
+		    &softc->rx_port_stats_ext->rx_discard_packets_cos7, "num of rx discard packets"
+		    "count on cos7");
+	}
+
+
 	return 0;
 }
 
@@ -720,6 +1060,39 @@ static char *bnxt_chip_type[] = {
 };
 #define MAX_CHIP_TYPE 3
 
+static char *bnxt_parse_pkglog(int desired_field, uint8_t *data, size_t datalen)
+{
+	char    *retval = NULL;
+	char    *p;
+	char    *value;
+	int     field = 0;
+
+	if (datalen < 1)
+		return NULL;
+	/* null-terminate the log data (removing last '\n'): */
+	data[datalen - 1] = 0;
+	for (p = data; *p != 0; p++) {
+		field = 0;
+		retval = NULL;
+		while (*p != 0 && *p != '\n') {
+			value = p;
+			while (*p != 0 && *p != '\t' && *p != '\n')
+				p++;
+			if (field == desired_field)
+				retval = value;
+			if (*p != '\t')
+				break;
+			*p = 0;
+			field++;
+			p++;
+		}
+		if (*p == 0)
+			break;
+		*p = 0;
+	}
+	return retval;
+}
+
 static int
 bnxt_package_ver_sysctl(SYSCTL_HANDLER_ARGS)
 {
@@ -727,11 +1100,9 @@ bnxt_package_ver_sysctl(SYSCTL_HANDLER_ARGS)
 	struct iflib_dma_info dma_data;
 	char *pkglog = NULL;
 	char *p;
-	char *next;
 	char unk[] = "<unknown>";
 	char *buf = unk;
 	int rc;
-	int field;
 	uint16_t ordinal = BNX_DIR_ORDINAL_FIRST;
 	uint16_t index;
 	uint32_t data_len;
@@ -749,27 +1120,11 @@ bnxt_package_ver_sysctl(SYSCTL_HANDLER_ARGS)
 			    &dma_data);
 			if (rc == 0) {
 				pkglog = dma_data.idi_vaddr;
-				/* NULL terminate (removes last \n) */
-				pkglog[data_len-1] = 0;
-
-				/* Set p = start of last line */
-				p = strrchr(pkglog, '\n');
-				if (p == NULL)
-					p = pkglog;
-
-				/* Now find the correct tab delimited field */
-				for (field = 0, next = p,
-				    p = strsep(&next, "\t");
-				    field <
-				    BNX_PKG_LOG_FIELD_IDX_PKG_VERSION && p;
-				    p = strsep(&next, "\t")) {
-					field++;
-				}
-				if (field == BNX_PKG_LOG_FIELD_IDX_PKG_VERSION)
+				p = bnxt_parse_pkglog(BNX_PKG_LOG_FIELD_IDX_PKG_VERSION, pkglog, data_len);
+				if (p && *p != 0 && isdigit(*p))
 					buf = p;
 			}
-		}
-		else
+		} else
 			dma_data.idi_vaddr = NULL;
 	}
 
@@ -819,9 +1174,6 @@ bnxt_create_ver_sysctls(struct bnxt_softc *softc)
 	SYSCTL_ADD_STRING(&vi->ver_ctx, SYSCTL_CHILDREN(oid), OID_AUTO,
 	    "driver_hwrm_if", CTLFLAG_RD, vi->driver_hwrm_if_ver, 0,
 	    "HWRM firmware version");
-	SYSCTL_ADD_STRING(&vi->ver_ctx, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "hwrm_fw", CTLFLAG_RD, vi->hwrm_fw_ver, 0,
-	    "HWRM firmware version");
 	SYSCTL_ADD_STRING(&vi->ver_ctx, SYSCTL_CHILDREN(oid), OID_AUTO,
 	    "mgmt_fw", CTLFLAG_RD, vi->mgmt_fw_ver, 0,
 	    "management firmware version");
@@ -1204,6 +1556,46 @@ bnxt_set_coal_tx_frames_irq(SYSCTL_HANDLER_ARGS) {
 	return rc;
 }
 
+static
+void simulate_reset(struct bnxt_softc *bp, char *fwcli_string)
+{
+	struct hwrm_dbg_fw_cli_input req = {0};
+	int rc = 0;
+
+	bnxt_hwrm_cmd_hdr_init(bp, &req, HWRM_DBG_FW_CLI);
+	req.cmpl_ring = -1;
+	req.target_id = -1;
+	req.cli_cmd_len = strlen(fwcli_string);
+	req.host_buf_len = 64 * 1024;
+	strcpy((char *)req.cli_cmd, fwcli_string);
+
+	BNXT_HWRM_LOCK(bp);
+	rc = _hwrm_send_message(bp, &req, sizeof(req));
+	if (rc) {
+		device_printf(bp->dev, " Manual FW fault failed, rc:%x\n", rc);
+	}
+	BNXT_HWRM_UNLOCK(bp);
+}
+
+static int
+bnxt_reset_ctrl(SYSCTL_HANDLER_ARGS) {
+	struct bnxt_softc *softc = arg1;
+	int rc = 0;
+	char buf[50] = {0};
+
+	if (softc == NULL)
+		return EBUSY;
+
+	rc = sysctl_handle_string(oidp, buf, sizeof(buf), req);
+	if (rc || req->newptr == NULL)
+		return rc;
+
+	if (BNXT_CHIP_P5(softc))
+		simulate_reset(softc, buf);
+
+	return rc;
+}
+
 int
 bnxt_create_config_sysctls_pre(struct bnxt_softc *softc)
 {
